Biblioteka/Models/Rental.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using FluentNHibernate.Mapping;


namespace Biblioteka.Models
{
    public class Rental
    {
        public virtual int Id { set; get; }
        public virtual Copy Copy { set; get; }
        public virtual Reader Reader { set; get; }
        public virtual string DateFrom { set; get; }
        public virtual string DateTo { set; get; }
        public virtual bool Deleted { set; get; }
        public virtual bool CloseReturnMailSent { set; get; }
        public virtual bool LateReturnMailSent { set; get; }


        public class Map : ClassMap<Rental>
        {
            public Map()
            {
                Table("Rentals");
                Id(x => x.Id).GeneratedBy.Identity();
                References(x => x.Copy).Column("CopyId");
                References(x => x.Reader).Column("ReaderId");
                Map(x => x.DateFrom).Not.Nullable();
                Map(x => x.DateTo).Not.Nullable();
                Map(x => x.Deleted).Not.Nullable();
                Map(x => x.CloseReturnMailSent).Nullable();
                Map(x => x.LateReturnMailSent).Nullable();


            }
        }
    }
}

Biblioteka/Controllers/MailController.cs
using Biblioteka.Models;
using Biblioteka.Models.Mail;
using NHibernate;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using EASendMail;

namespace Biblioteka.Controllers
{
    public class MailController : AuthorizationController
    {
        SmtpClient smtpClient = new SmtpClient();
        SmtpServer oServer = new SmtpServer("smtp.gmail.com")
        {
            Port = 587,
            ConnectType = SmtpConnectType.ConnectSSLAuto,
            User = MailFactory.EmailFrom,
            Password = "" 
        };

        public ActionResult SendMails(bool lateRental = false, bool closeReturn = false)
        {
            try
            {
                if (!IsLogged()) return RedirectToAction("Login", "Account");
                using (ISession session = database.MakeSession())
                {
                    ValidateReaderForbiddenAccess(session);
                    SmtpClient smtpClient = new SmtpClient();
                    if (lateRental)
                    {
                        SendLateRentalEmails(session);
                    }
                    if (closeReturn)
                    {

                        SendCloseReturnEmails(session);
                    }

                }
                return View();
            }
            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception e)
            {
                Debug.Write(e.Message);
                return RedirectToAction("Index", "Home");
            }


        }

        private void SendMail(String message, String subject, String mailTo)
        {
            SmtpMail smtpMail = new SmtpMail("TryIt")
            {
                From = MailFactory.EmailFrom,
                To = mailTo,
                Subject = subject,
                TextBody = message
            };

            smtpClient.SendMail(oServer, smtpMail);

        }

        private void SendLateRentalEmails(ISession session)
        {
            var allCurrentRentals = session.QueryOver<Rental>().Where(x => x.Deleted == false).List();
           
            foreach (var rental in allCurrentRentals)
            {
                if (IsRentalLate(rental))
                {

                    MailFactory mailFactory = new LateReturnFactory();
                    Mail lateReturn = mailFactory.CreateMail();

                    var message = lateReturn.CreateMessage(rental.Copy.Id, rental.Copy.Book.Title);
                    var subject = lateReturn.CreateSubject();
                    var mailTo = rental.Reader.User.Email;
                    SendMail(message, subject, mailTo);

                    using (ITransaction transaction = session.BeginTransaction())
                    {
                        rental.LateReturnMailSent = true;
                        session.SaveOrUpdate(rental);
                        transaction.Commit();
                    }


                }
            }

        }

        private void SendCloseReturnEmails(ISession session)
        {
            var allCurrentRentals = session.QueryOver<Rental>().Where(x => x.Deleted == false).List();


            foreach (var rental in allCurrentRentals)
            {
                if (IsRentalCloseToReturn(rental))
                {
                    MailFactory mailFactory = new CloseReturnFactory();
                    Mail closeReturn = mailFactory.CreateMail();
                    var message = closeReturn.CreateMessage(rental.Copy.Id, rental.Copy.Book.Title);
                    var subject = closeReturn.CreateSubject();
                    var mailTo = rental.Reader.User.Email;
                    SendMail(message, subject, mailTo);

                    using (ITransaction transaction = session.BeginTransaction())
                    {
                        rental.CloseReturnMailSent = true;
                        session.SaveOrUpdate(rental);
                        transaction.Commit();
                    }
                }
            }

        }
    }
}

Biblioteka/Controllers/RentalController.cs
using Biblioteka.Enums;
using Biblioteka.Models;
using Biblioteka.ModelViews;
using NHibernate;
using NHibernate.Criterion;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net.Mail;
using System.Web;
using System.Web.Mvc;
using EASendMail;
using Biblioteka.Service;

namespace Biblioteka.Controllers
{
    public class RentalController : AuthorizationController
    {
        // GET: Rental
        public ActionResult Index(bool deleted = false)
        {
            try
            {
                var smtp = new EASendMail.SmtpClient();

                if (!IsLogged()) { return RedirectToAction("Login", "Account"); }
                using (ISession session = database.MakeSession())
                {
                    ValidateReaderForbiddenAccess(session);
                    IList<Rental> rentals;
                    bool sendLateEmails = false;
                    bool sendCloseToReturnEmails = false;


                    if (deleted)
                    {
                        rentals = session.QueryOver<Rental>().Where(Restrictions.Eq("Deleted", true))
                            .OrderBy(x => x.DateFrom).Desc().List();
                        ViewBag.Info = "Past user rentals";
                        ViewBag.showReturnBtn = false;

                    }
                    else
                    {
                        rentals = session.QueryOver<Rental>().Where(Restrictions.Eq("Deleted", false)).
                             OrderBy(x => x.DateFrom).Desc().List();
                        ViewBag.Info = "Current user rentals";
                        ViewBag.showReturnBtn = true;


                    }
                    var rentalsData = new List<CopiesStatusesModelView>();


                    foreach (var ren in rentals)
                    {
                        var rental = new CopiesStatusesModelView()
                        {
                            Id = ren.Id,
                            CopyId = ren.Copy.Id,
                            Reader = ren.Reader.ToString(),
                            Title = ren.Copy.Book.Title,
                            BookId = ren.Copy.Book.Id,
                            DateFrom = ren.DateFrom,
                            DateTo = ren.DateTo

                        };
                        //sprawdzenie czy minal termin nieodebranych ksiazek

                        if (!deleted)
                        {
                            if (IsRentalLate(ren))
                            {
                                sendLateEmails = true;
                            }
                            else if(IsRentalCloseToReturn(ren))
                            {
                                sendCloseToReturnEmails = true;
                            }
                        }
                        rentalsData.Add(rental);

                    }

                    if (sendLateEmails)
                    {
                        ViewBag.ShowLateRentalButton = true;
                    }
                    if(sendCloseToReturnEmails)
                    {
                        ViewBag.ShowCloseToReturnRentalButton = true;
                    }

                    return View(rentalsData);
                }

            }
            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception e)
            {
                Debug.Write(e.Message);
                return RedirectToAction("Index", "Home");
            }
        }

       

        public ActionResult UserRentals()
        {
            try
            { 
                if (!IsLogged()) { return RedirectToAction("Login", "Account"); }
                using (ISession session = database.MakeSession())
                {
                    ValidateAdminAndEmployeeForbiddenAccess(session);
                    var reader = GetReader(session);

                    var rentals = session.QueryOver<Rental>().Where(x => x.Reader == reader).Where(x => x.Deleted == false).List();
                    var rentalsData = new List<CopiesStatusesModelView>();

                    foreach (var ren in rentals)
                    {
                        var rental = new CopiesStatusesModelView()
                        {                   

                        Id = ren.Id,
                            CopyId = ren.Copy.Id,
                            Reader = ren.Reader.ToString(),
                            Title = ren.Copy.Book.Title,
                            BookId = ren.Copy.Book.Id,
                            DateFrom = ren.DateFrom,
                            DateTo = ren.DateTo

                        }; 
                        rentalsData.Add(rental);      
                    }

                    return View(rentalsData);
                }
            }
            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception)
            {
                return RedirectToAction("Index", "Home");
            }
        }

        public ActionResult History()
        {
            try
            {
                if (!IsLogged()) { return RedirectToAction("Login", "Account"); }
                using (ISession session = database.MakeSession())
                {
                    ValidateAdminAndEmployeeForbiddenAccess(session);
                    var reader = GetReader(session);
                    var rentals = session.QueryOver<Rental>().Where(x => x.Reader == reader).OrderBy(x => x.DateFrom).Desc().Where(x => x.Deleted == true).List();
                    var historyData = new List<CopiesStatusesModelView>();
                    foreach (var ren in rentals)
                    {
                        var rental = new CopiesStatusesModelView()
                        {
                            Id = ren.Id,
                            CopyId = ren.Copy.Id,
                            Reader = ren.Reader.ToString(),
                            Title = ren.Copy.Book.Title,
                            BookId = ren.Copy.Book.Id,
                            DateFrom = ren.DateFrom,
                            DateTo = ren.DateTo

                        };
                        historyData.Add(rental);

                    }

                    return View(historyData);
                }
            }
            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception)
            {
                return RedirectToAction("Index", "Home");
            }
        }

        [HttpGet]
        public ActionResult Add(int reservationId)
        {
            try
            {
                if (!IsLogged()) { return RedirectToAction("Login", "Account"); }
                using (ISession session = database.MakeSession())
                {
                    ValidateReaderForbiddenAccess(session);
                    var reservation = session.Get<Reservation>(reservationId);
                    var copy = reservation.Copy;
                    LimitService limitService = LimitService.getInstance();
                    var limit = limitService.getLimit().MaxDaysOfRental;
                    var rental = new Rental()
                    {
                        Copy = copy,
                        Reader = reservation.Reader,
                        DateFrom = DateTime.Now.ToString("dd.MM.yyyy"),
                        DateTo = DateTime.Now.AddDays(limit).ToString("dd.MM.yyyy"),
                        Deleted = false,
                        CloseReturnMailSent = false,
                        LateReturnMailSent = false

                    };
                    copy.Status = Enums.Status.RENTED;

                    using (ITransaction transaction = session.BeginTransaction())
                    {
                        session.SaveOrUpdate(rental);
                        session.Delete(reservation);
                        session.SaveOrUpdate(copy);
                        session.Flush();
                        transaction.Commit();
                    }
                    return RedirectToAction("Index", "Reservation");
                }

            }
            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception)
            {
                return RedirectToAction("Index", "Home");
            }
        }


        [HttpGet]
        public ActionResult Return(int rentalId)
        {
            try
            {
                if (!IsLogged()) { return RedirectToAction("Login", "Account"); }
                using (ISession session = database.MakeSession())
                {
                    var rental = session.Get<Rental>(rentalId);
                    var copyId = rental.Copy.Id;
                    var copy = session.Get<Copy>(copyId);
                    copy.Status = Enums.Status.IN_STOCK;
                    rental.Deleted = true;
                    using (ITransaction transaction = session.BeginTransaction())
                    {
                        session.SaveOrUpdate(rental);
                        session.SaveOrUpdate(copy);
                        session.Flush();
                        transaction.Commit();
                    }

                    //PENDINGS
                    var pending = session.QueryOver<Pending>().Where(x => x.Copy == copy).
                        OrderBy(x => x.DateFrom).Asc().Take(1).SingleOrDefault();


                    if (pending != null)
                    {
                        var limit = 30; //@todo
                        var newReservation = new Reservation()
                        {
                            Copy = copy,

Biblioteka/Views/Rental/History.cshtml
@model IEnumerable<Biblioteka.ModelViews.CopiesStatusesModelView>

@{
    ViewBag.Title = "HistoryRentals";
}


<table class="col-md-12">
    <tr>
        <td class="col-md-2" style="margin:10px">
            <ul class="nav nav-pills nav-stacked ">
                <li><a class="redirect-button" href="/Reservation/UserReservations">Reservations</a></li>
                <li><a class="redirect-button" href="/Rental/UserRentals">Rentals</a></li>
                <li><a class="redirect-button" href="/Pending/UserPendings">Pendings</a></li>
                <li class="active"><a href="/Rental/History">History rentals</a></li>
                <li><a class="redirect-button" href="/Fine/UserFines">Fines</a></li>

            </ul>
        </td>
        <td class="col-md-10" style="margin:10px">
            <h2>History of your rentals</h2>

            @{
                if (Model.Count() != 0)
                {
                    <table class="table ">
                        <tr>
                            <th>
                                @Html.DisplayNameFor(model => model.Title)
                            </th>
                            <th>
                                @Html.DisplayNameFor(model => model.Reader)
                            </th>
                            <th>
                                @Html.DisplayNameFor(model => model.DateFrom)
                            </th>
                            <th>
                                @Html.DisplayNameFor(model => model.DateTo)
                            </th>
                            <th></th>
                        </tr>

                        @foreach (var item in Model)
                        {
                            <tr>
                                <td>
                                    @Html.ActionLink(item.Title, "Details/" + item.BookId, "Book", null, new { @class = "redirect-button" })
                                </td>
                                <td>
                                    @Html.DisplayFor(modelItem => item.Reader)
                                </td>
                                <td>
                                    @Html.DisplayFor(modelItem => item.DateFrom)
                                </td>
                                <td>
                                    @Html.DisplayFor(modelItem => item.DateTo)
                                </td>
                            </tr>
                        }

                    </table>
                }
                else
                {
                    <hr />
                    <p class="empty-data-table"> You haven't got any history</p>
                    @Html.ActionLink("Go to book catalog", "Index", "Book",null, new { @class = "redirect-button" })
                }
            }

        </td>
    </tr>
</table>

Biblioteka/Views/Rental/Index.cshtml
@model IEnumerable<Biblioteka.ModelViews.CopiesStatusesModelView>
<script src="~/Scripts/jquery-1.10.2.min.js"></script>
<script src="~/Scripts/validateDates.js"></script>



@{
    ViewBag.Title = "Index";
}

@using (Html.BeginForm())
{
    <table>
        <tr>
            <th>
                @if (ViewBag.showReturnBtn)
                {
                <label class="radio"><input type="radio" name="deleted" checked value=false id="current">Current rentals</label>
                <label class="radio"><input type="radio" name="deleted" value=true id="past">Past rentals</label>
                }
                else
                {                
                <label class="radio"><input type="radio" name="deleted" value=false id="current">Current rentals</label>
                <label class="radio"><input type="radio" name="deleted"  checked value=true id="past">Past rentals</label>

                }</th>

            <th>
                <input type="submit" value="Filter" class="btn default-button" style="margin:10px" />
            </th>
        </tr>
    </table>
}
<p style="margin:30px"></p>

<div class="header-title">@ViewBag.Info</div>
<p style="margin:30px"></p>
@{
    if (Model.Count() != 0)
    {

        <table class="table" id="rentalsTable">
            <tr>
                <th>
                    @Html.DisplayNameFor(model => model.CopyId)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.Title)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.Reader)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.DateFrom)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.DateTo)
                </th>
                <th></th>
            </tr>

            @foreach (var item in Model)
            {
                <tr>
                    <td>
                        @Html.DisplayFor(modelItem => item.CopyId)
                    </td>
                    <td>
                        @Html.ActionLink(item.Title, "Details/" + item.BookId, "Book", null, new { @class = "redirect-button" })
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Reader)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.DateFrom)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.DateTo, new { id = "dateTo" })
                    </td>
                    @if (ViewBag.showReturnBtn) { 
                    <td>
                        @Html.ActionLink("Return", "Return", new { rentalId = item.Id }, new { @class = "redirect-button" })
                    </td>
                    }
                </tr>
            }



        </table>
    }
    else
    {
        <hr />
        <p class="empty-data-table"> There's no current rentals</p>
    }
}

@if (ViewBag.ShowLateRentalButton != null)
{
    <p>
        @Html.ActionLink("Send emails with warning about late rentals", "SendMails", "Mail", new { lateRental = true }, new { @class = "btn btn-danger" })
    </p>
}
@if (ViewBag.ShowCloseToReturnRentalButton != null)
{
    <p>
        @Html.ActionLink("Send emails with notification to return books in 3 days", "SendMails", "Mail", new { closeReturn = true }, new { @class = "btn btn-warning" })
    </p>
}

Biblioteka/Views/Rental/UserRentals.cshtml
@model IEnumerable<Biblioteka.ModelViews.CopiesStatusesModelView>

@{
    ViewBag.Title = "UserRentals";
}

<table class="col-md-12">
    <tr>
        <td class="col-md-2" style="margin:10px">
            <ul class="nav nav-pills nav-stacked ">
                <li><a class="redirect-button" href="/Reservation/UserReservations">Reservations</a></li>
                <li class="active"><a href="/Rental/UserRentals">Rentals</a></li>
                <li><a class="redirect-button" href="/Pending/UserPendings">Pendings</a></li>
                <li><a class="redirect-button" href="/Rental/History">History rentals</a></li>
                <li><a class="redirect-button" href="/Fine/UserFines">Fines</a></li>

            </ul>
        </td>
        <td class="col-md-10" style="margin:10px">
            <h2> Your rentals</h2>

            @{
                if (Model.Count() != 0)
                {
                    <table class="table ">
                        <tr>

                            <th>
                                @Html.DisplayNameFor(model => model.Title)
                            </th>
                            <th>
                                @Html.DisplayNameFor(model => model.DateFrom)
                            </th>
                            <th>
                                @Html.DisplayNameFor(model => model.DateTo)
                            </th>
                            <th></th>
                        </tr>

                        @foreach (var item in Model)
                {
                            <tr>

                                <td>
                                    @Html.ActionLink(item.Title, "Details/" + item.BookId, "Book", null, new { @class = "redirect-button" })
                                </td>
                                <td>
                                    @Html.DisplayFor(modelItem => item.DateFrom)
                                </td>
                                <td>
                                    @Html.DisplayFor(modelItem => item.DateTo)
                                </td>
                                <td></td>
                            </tr>
                        }

                    </table>
                }
                else
                {
                    <hr />
                    <p class="empty-data-table"> You don't have got any rentals</p>
                    @Html.ActionLink("Go to book catalog", "Index", "Book")
                }
            }
            
        </td>
    </tr>
</table>